#ifndef __NIXIE_H
#define __NIXIE_H

/***************************************************************
功能 : mbed的串联74HC595数码管驱动
作者 : 陈欢 清华大学电机工程与应用电子技术系
邮箱 : h-che14@mails.tsinghua.edu.cn OR heroistired@gmail.com
声明 : 
本程序仅供学习与交流使用,如需他用,须联系作者
本程序可以随意更改,但须保留本信息页
All rights reserved
2017.6.16
***************************************************************/

#include "mbed.h"

const char NumCode[]={0xc0,0xf9,0xa4,0xb0,0x99,0x92,0x82,0xf8,0x80,0x90};
const char SegBit[]={0x80,0x40,0x20,0x10,0x08,0x04,0x02,0x01};

//数码管类 
class  Nixie
{
    public:
        Nixie(PinName _DIO, PinName _SCK, PinName _RCK);
        void NixieShow(int Num, int Pos, bool WithDot);
        void NixieShowNumber(int Number, int dot);
  
    protected:
        DigitalOut DIO;
        DigitalOut SCK;
        DigitalOut RCK;
};
#endif